#include <stdio.h>
#include <io.h>
#include <string.h>
#include <bios.h>
#include <dos.h>
#include "tools.h"
#include "changjei.h"

#define ON       1
#define OFF      0

extern int KEY_STATUS;

struct CJ_STRU CJ={ 0 };

int      ftab;
char     CHANGJEI[6];
void     KeyNormal(int ch);

void ChangjeiClear()
{
   char str[81];

   CJ.CNT  =0;
   if(CJ.MODE==CHANG) sprintf(str,"%-80s","eܾef  rڡG"); else sprintf(str,"%-80s","e²f  rڡG");
   ColorPuts1(1,25,str,F_WHITE);
}

void ChangjeiGetBig(int offset,int cnt)
{
   int           sw;
   unsigned char ch1,ch2;

   sw=offset;
   if(sw<5401)
   {
      ch1=(sw/157) + 0xa4;
      ch2=(sw%157);
      if(ch2>(0x7e-0x40)) ch2=0xa1+(ch2-(0x7e-0x40)-1); else ch2=0x40+ch2;
   }
   else
   {
      sw -=5401;
      ch1=sw/157 + 0xc9;
      ch2=sw%157;
      if(ch2>(0x7e-0x40)) ch2=0xa1+(ch2-(0x7e-0x40)-1); else ch2=0x40+ch2;
   }

   CJ.MUTIL[cnt] =ch1+(((unsigned)ch2) << 8);
}

void ChangjeiMapLetter(int x, int pos)
{
   char LETTER[]="  gˤQj@}HߤfrܤskЭR";
   char str[3];

   str[0]=LETTER[pos*2];
   str[1]=LETTER[pos*2+1];
   str[2]='\0';
   ColorPuts1(x*2+18,25,str,F_CYAN);
}

int ChangjeiGetWord()
{
   char num[5];
   int  i,cnt,size,offset;
   int  position[20];
   union
   {
      unsigned long  sum;
      unsigned char  ch[3];
   }  compress;
   unsigned char *ts,buffer[3073];

   compress.sum=0;
   for(i=0;i<5;i++) num[i]=0;
   for(i=0;i<CJ.CNT;i++) { num[i]=(char)(CHANGJEI[i]-'A'+1); }
   if(CJ.CNT>1)
   {
      i            =num[1];
      num[1]       =num[CJ.CNT-1];
      num[CJ.CNT-1]=i;
   }

   for(i=0;i<5;i++) { compress.sum=(compress.sum*27)+num[i]; }

   cnt=0;  lseek(ftab,0,SEEK_SET);  offset=0;
   while(1)
   {
      if((size=read(ftab,buffer,3072))==0) break;
      ts=buffer;
      for(i=0;i<(size/3);i++)
      {
         if(compress.ch[0]==ts[0] && compress.ch[1]==ts[1] && compress.ch[2]==ts[2])
         {
            position[cnt++]=offset;
         }
         offset++;
         ts +=3;
      }
   }

   if(cnt)
   {
      for(i=0;i<cnt;i++)  ChangjeiGetBig(position[i],i);
   }
   return(cnt);
}


unsigned ChangjeiSelectWord(int cnt)
{
   int  i,ch,offset;
   int  EXIT=OFF;
   char str[80],str1[6];

   // ----------------- DЦrBz -------------------
   if(cnt==1) return(CJ.MUTIL[0]);

   // ------------------ ЦrBz --------------------
   strcpy(str,"");
   for(i=0,offset=0;i<cnt && i<9;i++)                   // ܦr
   {
      sprintf(str1,"%d%c%c ",i+1,CJ.MUTIL[i] & 0x00ff,(CJ.MUTIL[i] & 0xff00) >> 8 );
      strcat(str,str1);
   }
   if((offset+9)<cnt) strcat(str," >>");
   ColorPuts1(18,25,str,F_CYAN);

   if(CJ.MODE==CHANG)                                   // ܾer
   {
      while(1)
      {
         while((ch=GetKey())==-1);
         if(ch==0x1b) return(0);
         ch=ch-'1';
         if(ch>=0 && ch<cnt) break;
      }
   }
   else
   {
      while(!EXIT)                                      // ²r
      {
         while((ch=GetKey())==-1);
         switch(ch)
         {
            case 0x1b : // ESC
                 return(0);
            case ' '  : // SPACE
                 if(cnt<=9)          break;
                 if((offset+9)>=cnt) offset=0; else offset+=9;
                 strcpy(str,"");
                 for(i=offset;i<cnt && i<(offset+9);i++)        // ܦr
                 {
                    sprintf(str1,"%d%c%c ",i+1-offset,CJ.MUTIL[i] & 0x00ff,(CJ.MUTIL[i] & 0xff00) >> 8 );
                    strcat(str,str1);
                 }
                 if((offset+9)<cnt) strcat(str," >>");
                 ChangjeiClear();
                 ColorPuts1(18,25,str,F_CYAN);
                 break;
            default :
                EXIT=ON;
                ch -='1';
                if(ch<=0 || ch>cnt || ch>9) ch=offset; else ch +=offset;
                break;
         }
      }
   }
   return(CJ.MUTIL[ch]);
}

void ChangjeiDo()
{
   unsigned ch;
   int      sw;

   if((sw=GetWord())!=0)                                // Ǧ^iܪr
   {
      if((ch=ChangjeiSelectWord(sw))!=0)                // D ESC
      {
         KeyNormal(ch & 0x00ff);
         KeyNormal((ch & 0xff00)>>8);
      }
   }
   ChangjeiClear();
}

int GetWord()
{
   if(CJ.MODE==CHANG) return(ChangjeiGetWord()); else return(EasyGetWord());
}

int Changjei(int ch)
{
   int al,ah;

   if(KEY_STATUS!=0x00) return(ch);

   ah=(ch & 0xff00)>>8;
   al=toupper((ch & 0x00ff));
   if(ah!=0) return(ch);

   switch(al)
   {
      case 0x1b : // ESC
           if(CJ.CNT==0) return(ch);
           ChangjeiClear();
           break;
      case ' '  : // SPACE
           if(CJ.CNT==0)  return(ch);
           ChangjeiDo();
           break;
      case 0x08 : // BackSpace
           if(CJ.CNT==0)  return(ch);
           CJ.CNT--;
           ChangjeiMapLetter(CJ.CNT,0);
           break;
      default   :
           if(al<'A' || al>='Z') return(ch);
           if(CJ.CNT==5)         return(0);
           CHANGJEI[CJ.CNT]=al;
           ChangjeiMapLetter(CJ.CNT++,al-'A'+1);
           if(CJ.MODE==EASY && CJ.CNT==2) { ChangjeiDo(); }     // ²J
           break;
   }
   return(0);
}

int EasyGetWord()
{
   char num[5];
   int  i,cnt,size,offset;
   int  position[200];
   union
   {
      unsigned long  sum;
      unsigned char  ch[3];
   }  compress;
   unsigned long sum1,sum2;
   unsigned char *ts,buffer[3073];

   for(i=0;i<5;i++) num[i]=0;
   for(i=0;i<CJ.CNT;i++) { num[i]=(char)(CHANGJEI[i]-'A'+1); }

   sum1  =(unsigned long)num[0]*27*27*27*27;
   sum1 +=(unsigned long)num[1]*27*27*27;
   sum2  =sum1+19683;                                   /* 27*27*27 */

   compress.sum=0L;
   cnt=0;  lseek(ftab,0,SEEK_SET);  offset=0;
   while(1)
   {
      if((size=read(ftab,buffer,3072))==0) break;
      ts=buffer;
      for(i=0;i<(size/3);i++)
      {
         compress.ch[0]=ts[0];
         compress.ch[1]=ts[1];
         compress.ch[2]=ts[2];
         if(sum1<=compress.sum && compress.sum<sum2)
         {
            position[cnt++]=offset;
         }
         offset++;
         ts +=3;
      }
   }
   if(cnt)
   {
      for(i=0;i<cnt;i++)  ChangjeiGetBig(position[i],i);
   }
   return(cnt);
}
