#include <stdio.h>
#include <string.h>
#include <math.h>
#include "we.h"
#include "tools.h"
#include "mark.h"
#include "allocmem.h"
#include "cursor.h"
#include "profile.h"

#define ON      1
#define OFF     0

extern struct CTRL_STRUCT       CTRL;
extern struct POS_STRUCT        POS;
extern struct DISPLAY_STRUCT    DISPLAY;
extern struct LINE_STRUCT       LINE;
extern struct PUSH_STRUCT       PUSH;
extern struct MACRO_STRUCT      MACRO;
extern struct LAST_STRUCT       LAST;

extern struct BACKUP            *ACTIVE;
extern struct LINK              *new;
extern struct LINK              *now;
extern struct LINK              *head;
extern struct LINK              *tail;
extern struct LINK              *NEW;

extern int                      MARK_EXCHANGE;
extern int                      MARKCOLOR;
extern int                      MONITOR;
extern int                      KEY_STATUS;
extern int                      U_LEN;          //  UnCompress string length
extern int                      C_LEN;          //  Compress   String length
extern char                     U_STR[256];     //  UnCompress String
extern char                     C_STR[256];     //  Compress   String
extern char                     RESULT[40];
extern char                     FNAME[80];
extern char                     text[256];
extern char                     tbl[][3];
extern char                     *DP;



void MarkAlign(int init)
{
   static        mode;
   struct LINK   *tmp;
   int           i,j,len,sw;
   int           scrx,scrx1;
   char          str[256],str1[256];
   struct BACKUP *BAKtmp=NULL;

   if(!CTRL.MARK)  return;

   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   // ------------------  Ctrl-A ɷ|ǤJ 0  1 ------------------
   if(init)   mode=0; else { mode++; mode %=3; }

   // --- (AlignLeft, AlignRight, AlignCenter) OǤJ 2,3,4 ---
   if(init>1) mode=init-2;

   MallocData(now,text);
   now=NEW;
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;      // V POS.MARKY 檺

   if(POS.MARKX ==0) scrx =1;   else  scrx =POS.MARKX;
   if(POS.MARKX1==0) scrx1=255; else  scrx1=POS.MARKX1;

   for(i=POS.MARKY;i<=POS.MARKY1;i++)           // MARK ϰJr
   {
      // ------------------  MARK ϸɪť ------------------
      PointerData(tmp);
      strcpy(str,U_STR);
      len=U_LEN;
      if(scrx1>len)
      {
         for(j=len;j<scrx1;j++) str[j]=' ';
         str[scrx1]='\0';
      }

      MidStr(str1,str,scrx,(scrx1-scrx+1));
      EraseSpace(str1);
      len=strlen(str1);

      if(str1[0]!='\0' && len!=(scrx1-scrx+1))
      {
         switch(mode)
         {
             case  0 :  // V勵
                   for(j=0  ;j<len           ;j++)      str[scrx+j-1]=str1[j];
                   for(j=len;j<(scrx1-scrx+1);j++)      str[scrx+j-1]=' ';
                   break;
             case  1 :  // Vk勵
                   sw=scrx1-scrx+1-len;
                   for(j=0  ;j<sw            ;j++)      str[scrx+j-1]=' ';
                   for(j=sw ;j<(scrx1-scrx+1);j++)      str[scrx+j-1]=str1[j-sw];
                   break;
             case  2 :  // V勵
                   sw=((scrx1-scrx+1)-len)/2;
                   for(j=0  ;j<sw       ;j++)           str[scrx+j-1]=' ';
                   for(j=sw ;j<(len+sw) ;j++)           str[scrx+j-1]=str1[j-sw];
                   for(j=(len+sw);j<(scrx1-scrx+1);j++) str[scrx+j-1]=' ';
                   break;
         }
      }

      for(j=(strlen(str)-1);j>=0;j--) { if(str[j]==' ') str[j]=0; else break; }

      //------------  now=tmp , now ]QV NEW ----------
      if(tmp==now) { sw=MallocData(tmp,str); now=NEW; } else sw=MallocData(tmp,str);
      if(!sw) break;
      tmp=NEW;
      tmp=tmp->next;
   }
   NowdataToText(now);

   // ----- MARK ɬO_u@ , ݤݭs ------
   MarkRedisplay(BAKtmp,1);

   if(!CTRL.MACRO)
   {
      if(mode==0) DisplayMessageNoBeep("{V勵,  Ctrl-A Vk勵");
      if(mode==1) DisplayMessageNoBeep("{Vk勵,  Ctrl-A V勵");
      if(mode==2) DisplayMessageNoBeep("{V勵,  Ctrl-A V勵");
   }
}

void MarkFill(char *fstr)
{
   struct LINK *tmp;
   int  i,j,len,len1;
   int  scrx,scrx1;
   int  posy,posy1;
   int  scr,cnt,sw;
   char str[512],str1[256];
   struct BACKUP *BAKtmp=NULL;

   if(!CTRL.MARK)  return;

   if(fstr==NULL || *fstr=='\0')
   {
      DisplayMessageNoBeep("T : пJr    (Esc )");
      LocateXY(19,LINE.MESSAGE);
      str1[0]=(char)Getch();
      str1[1]='\0';
      DisplayMessage(" ",OFF);
      if(str1[0]==0x1b) return;
   }
   else
   {
      strcpy(str1,fstr);
   }

   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;      // V POS.MARKY 檺

   if(POS.MARKX ==0) scrx =1;   else  scrx =POS.MARKX;
   if(POS.MARKX1==0) scrx1=255; else  scrx1=POS.MARKX1;

   for(i=POS.MARKY;i<=POS.MARKY1;i++)           // MARK ϰJr
   {
      PointerData(tmp);
      strcpy(str,U_STR);
      len=U_LEN;
      if(scrx>len)                              //  MARK ϸɪť
      {
         for(j=len;j<(scrx-1);j++) str[j]=' ';
         str[scrx-1] =str[scrx] ='\0';
         len=scrx;
      }

      for(j=(scrx-1),len1=strlen(str1);j<scrx1;j++)     // ϰJ FILL STRING
      {
         str[j]=str1[(j-scrx+1)%len1];
      }

      if(len<=scrx1)          str[scrx1]='\0';

      //------  now=tmp , now ]QV NEW ------
      if(tmp==now) { sw=MallocData(tmp,str); now=NEW; } else sw=MallocData(tmp,str);
      if(!sw) break;
      tmp=NEW;
      tmp=tmp->next;
   }
   NowdataToText(now);

   // ----- MARK ɬO_u@ , ݤݭs ------
   MarkRedisplay(BAKtmp,1);
}

// return :  (-1) LаO  (-2) MаOϬ۽Ĭ  (1) `
int MarkCopy()
{
   struct BACKUP *BAKtmp=NULL;
   struct LINK   *mark_head;
   struct LINK   *buf;
   int           i,j,len,cnt,sw;
   int           markx,markx1;
   int           marky,marky1;
   char          str[512],str1[512],str2[512],str3[512];
   unsigned      seg;

   if(!CTRL.MARK)   return(-1);
   if(CTRL.COMMAND) return(-1);

   //----------- ثebаOϤ ------------
   if(CTRL.MARKFILE==ACTIVE && (POS.NOWY>=POS.MARKY && POS.NOWY<POS.MARKY1))
   {
      if(POS.MARKX==0)  return(-2);                     // MаOϬ۽Ĭ
   }

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   BAKtmp=ACTIVE;
   if(CTRL.MARKFILE!=ACTIVE) ChangeEditStatus(CTRL.MARKFILE);

   mark_head=head;
   for(i=1;i<POS.MARKY;i++) mark_head=mark_head->next;  // V POS.MARKY 檺

   ChangeEditStatus(BAKtmp);
   buf=now;
   if(POS.MARKX==0)                             // LINE MARK
   {
      for(i=POS.MARKY,cnt=0;i<=POS.MARKY1;i++)  // MARK ϰ@Bz
      {
         PointerData(mark_head);
         strcpy(str,DP);
         if((new=AllocMemString(str))==NULL) break;
         PointerData(new);
         strcpy(DP,str);

         new->prev=buf;
         new->next=buf->next;
         if(buf->next!=NULL)  (buf->next)->prev=new;  else  tail=new;
         buf->next=new;
         mark_head=mark_head->next;
         buf=buf->next;
         cnt++;
      }

      // --------------- иbаOϤW ----------------
      if(CTRL.MARKFILE==ACTIVE && POS.NOWY<POS.MARKY)     { POS.MARKY +=cnt; POS.MARKY1 +=cnt; }

      // --------- иbаOϤW(Push Mark) -----------
      if(PUSH.CTRL)
      {
         if(PUSH.MARKFILE==ACTIVE && POS.NOWY<PUSH.MARKY)
         {
            PUSH.MARKY +=cnt; PUSH.MARKY1 +=cnt;
         }
      }
      POS.MAXY +=cnt;
   }
   else                                         // BLOCK MARK
   {
      // ------- P_O_M MARK ҩĲ --------
      markx =POS.NOWX;
      markx1=POS.NOWX+(POS.MARKX1-POS.MARKX);
      marky =POS.NOWY;
      marky1=POS.NOWY+(POS.MARKY1-POS.MARKY);

      // ------- wwƻsϪ, b MARK Ϥe
      // ------- wwƻsϪ, b MARK Ϥe
      if(CTRL.MARKFILE==ACTIVE)
      {
         if((marky >POS.MARKY  && marky<=POS.MARKY1) && POS.NOWX<=POS.MARKX1) return(-2);
         if((marky1>=POS.MARKY && marky1<POS.MARKY1) && POS.NOWX<=POS.MARKX1) return(-2);

         for(i=0;i<(POS.MARKY1-POS.MARKY+1);i++)
         {
            if((POS.NOWY+i)>=POS.MARKY && (POS.NOWY+i)<=POS.MARKY1)
            {
               if( !(POS.NOWY==POS.MARKY && POS.NOWX<=POS.MARKX) )
               {
                  if((markx > POS.MARKX && markx <=POS.MARKX1) ||
                     (markx1>=POS.MARKX && markx1< POS.MARKX1))  return(-2);
               }
            }
         }
      }

      // ---------------------------------------
      for(i=POS.MARKY;i<=POS.MARKY1;i++)                // MARK ϰ@Bz
      {
         PointerData(buf);
         strcpy(str,U_STR);
         len=U_LEN;
         if(POS.NOWX>len)                               // аϸɪť
         {
            for(j=len;j<(POS.NOWX-1);j++) str[j]=' ';
            str[POS.NOWX-1] =str[POS.NOWX] ='\0';
            len=POS.NOWX;
         }

         PointerData(mark_head);
         MidStr(str1,U_STR,POS.MARKX,(POS.MARKX1-POS.MARKX+1));

         len=strlen(str1);
         for(j=len;j<(POS.MARKX1-POS.MARKX+1);j++) { str1[j]=' '; }
         str1[j]='\0';

         MidStr(str2,str,1,(POS.NOWX-1));               // rꭺ
         MidStr(str3,str,POS.NOWX,255);                 // ЩҦbr

         strcpy(str,str2);
         strcat(str,str1);
         strcat(str,str3);
         str[255]='\0';

         if(buf==now) { sw=MallocData(buf,str); now=NEW; } else sw=MallocData(buf,str);
         if(!sw) break;                                 // MallocData() , O^
         buf=NEW;

         if(buf->next==NULL && i!=POS.MARKY1)           // ̫@,tmsŶ
         {
            if((new=AllocMemString(""))!=NULL)
            {
               PointerData(new);
               strcpy(DP,"\0");
               new->prev=buf;
               new->next=NULL;
               buf->next=new;
               tail     =new;
               POS.MAXY++;
            }
            else
            {
               break;
            }
         }
         mark_head=mark_head->next;
         buf=buf->next;
      }
      NowdataToText(now);

      // ---------------- аϦb MARK ϥ ------------
      if(POS.NOWY==POS.MARKY && POS.NOWX<=POS.MARKX && CTRL.MARKFILE==ACTIVE)
      {
         cnt=(POS.MARKX1-POS.MARKX+1);
         POS.MARKX  +=cnt;
         POS.MARKX1 +=cnt;
      }
   }

   CompareRedraw(POS.SCRY,(LINE.SCRY1-LINE.SCRY+1));

   if(CTRL.MODIFY==OFF)                      // P_ɮ׬O_Qק
   {
      CTRL.MODIFY=ON;
      DisplayFname(FNAME);
   }
   return(0);
}


void MarkBegin()
{
   if(CTRL.MARK)
   {
      if(CTRL.MARKFILE!=ACTIVE) ChangeFile(CTRL.MARKFILE);
      CmdLine(POS.MARKY);
   }
}

void MarkEnd()
{
   if(CTRL.MARK)
   {
      if(CTRL.MARKFILE!=ACTIVE) ChangeFile(CTRL.MARKFILE);
      CmdLine(POS.MARKY1);
   }
}

void MarkDelete()
{
   int y,y1,x,x1;
   struct BACKUP *BAKtmp=NULL;

   if(!CTRL.MARK) return;

   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   y =POS.MARKY;   y1=POS.MARKY1;
   x =POS.MARKX;   x1=POS.MARKX1;

   CTRL.MARK    =OFF;
   CTRL.MARKFILE=NULL;
   POS.MARKY1=POS.MARKY=0;
   POS.MARKX1=POS.MARKX=0;

   if(!x) DeleteLine(y,y1);  else  DeleteBlock(y,y1,x,x1);

   if(BAKtmp!=NULL)                     // MARK ɤu@ , ݭs
   {
      ChangeEditStatus(BAKtmp);
      DISPLAY.REDISPLAY=OFF;
      DISPLAY.SCRY     =1;
      DISPLAY.CNT      =0;
      DisplayFname(FNAME);              // b DeleteLine , FNAME |ܦ, ݦA^_
   }
   ChangeMessage();
}

void MarkMove()
{
   int scry=(LINE.SCRY1-LINE.SCRY+1),liney=0;
   int marky,marky1;

   if(!CTRL.MARK)   return;
   if(CTRL.COMMAND) return;

   marky =POS.NOWY;
   marky1=POS.NOWY+(POS.MARKY1-POS.MARKY);

   // ----- ЦCb MARK Cϰ줤 , BЦ渨b MARK ϰ -----
   if(CTRL.MARKFILE==ACTIVE && POS.MARKX!=0)
   {
      if(marky >POS.MARKY  && marky <=POS.MARKY1 && POS.NOWX>=POS.MARKX) return;
      if(marky1>=POS.MARKY && marky1< POS.MARKY1 && POS.NOWX>=POS.MARKX) return;
   }

   if(MarkCopy()==0)
   {
      if(DISPLAY.REDISPLAY)
      {
         scry =DISPLAY.SCRY;
         liney=DISPLAY.SCRY+DISPLAY.CNT-1;              // sܪ̩

         DISPLAY.REDISPLAY=OFF;
         DISPLAY.SCRY     =1;
         DISPLAY.CNT      =0;
      }
      MarkDelete();
      if(DISPLAY.REDISPLAY)
      {
         if((DISPLAY.SCRY+DISPLAY.CNT-1)>liney)  liney=(DISPLAY.SCRY+DISPLAY.CNT-1);
         if(DISPLAY.SCRY<scry) scry=DISPLAY.SCRY;
      }
      CompareRedraw(scry,(liney-scry+1));
      ChangeMessage();
   }
}

void MarkPush()
{
   PUSH.CTRL     =ON;
   PUSH.CTRL_MARK=CTRL.MARK;
   PUSH.MARKFILE =CTRL.MARKFILE;
   PUSH.MARKY    =POS.MARKY;
   PUSH.MARKY1   =POS.MARKY1;
   PUSH.MARKX    =POS.MARKX;
   PUSH.MARKX1   =POS.MARKX1;
   UnMark();
}

void MarkPop()
{
   CTRL.MARK     =PUSH.CTRL_MARK;                   // PUSH e CTRL.MARK A
   CTRL.MARKFILE =PUSH.MARKFILE;                    // PUSH e CTRL.MARKFILE A
   POS.MARKY =PUSH.MARKY ;
   POS.MARKY1=PUSH.MARKY1;
   POS.MARKX =PUSH.MARKX ;
   POS.MARKX1=PUSH.MARKX1;

   PUSH.CTRL     =OFF;
   PUSH.CTRL_MARK=OFF;
   PUSH.MARKFILE =NULL;
   PUSH.MARKY    = PUSH.MARKY1 =PUSH.MARKX =PUSH.MARKX1 =0;
   DisplayMark(1,(LINE.SCRY1-LINE.SCRY+1));
   ChangeMessage();
}

int MarkOverlay()
{
   struct LINK *mark_head;
   struct LINK *buf;
   int  i,j,len,sw;
   int  markx,markx1;
   int  marky,marky1;
   char str[512],str1[512],str2[512],str3[512];
   struct BACKUP *BAKtmp=NULL;
   unsigned seg;

   if(!CTRL.MARK || POS.MARKX==0) return(-1);
   if(CTRL.COMMAND)               return(-1);

   // ------- P_O_M MARK ҩĲ --------
   markx =POS.NOWX;
   markx1=POS.NOWX+(POS.MARKX1-POS.MARKX);
   marky =POS.NOWY;
   marky1=POS.NOWY+(POS.MARKY1-POS.MARKY);

   // ------- wwƻsϪ, b MARK Ϥe
   // ------- wwƻsϪ, b MARK Ϥe
   if(CTRL.MARKFILE==ACTIVE)
   {
      if((marky >=POS.MARKY && marky <=POS.MARKY1) ||
         (marky1>=POS.MARKY && marky1<=POS.MARKY1))
      {
         if((markx >=POS.MARKX && markx <=POS.MARKX1) ||
            (markx1>=POS.MARKX && markx1<=POS.MARKX1)) return(-1);
      }
   }

   BAKtmp=ACTIVE;
   if(CTRL.MARKFILE!=ACTIVE) ChangeEditStatus(CTRL.MARKFILE);

   mark_head=head;
   for(i=1;i<POS.MARKY;i++) mark_head=mark_head->next;  // V POS.MARKY 檺

   ChangeEditStatus(BAKtmp);
   buf=now;
   for(i=POS.MARKY;i<=POS.MARKY1;i++)           // MARK ϰ@Bz
   {
      PointerData(buf);
      strcpy(str,U_STR);
      len=U_LEN;
      if(POS.NOWX>len)                          // аϸɪť
      {
         for(j=len;j<(POS.NOWX-1);j++) str[j]=' ';
         str[POS.NOWX-1] =str[POS.NOWX] ='\0';
         len=POS.NOWX;
      }

      PointerData(mark_head);
      MidStr(str1,U_STR,POS.MARKX,(POS.MARKX1-POS.MARKX+1));

      len=strlen(str1);
      for(j=len;j<(POS.MARKX1-POS.MARKX+1);j++) { str1[j]=' '; }
      str1[j]='\0';

      MidStr(str2,str,1,(POS.NOWX-1));                          // rꭺ
      MidStr(str3,str,POS.NOWX+(POS.MARKX1-POS.MARKX+1),255);   // +MARK, r

      strcpy(str,str2);
      strcat(str,str1);
      strcat(str,str3);
      str[255]='\0';

      if(buf==now) { sw=MallocData(buf,str); now=NEW; } else sw=MallocData(buf,str);
      if(!sw) break;
      buf=NEW;

      if(buf->next==NULL && i!=POS.MARKY1)           // ̫@,tmsŶ
      {
         if((new=AllocMemString(""))!=NULL)
         {
            PointerData(new);
            strcpy(DP,"\0");
            new->prev=buf;
            new->next=NULL;
            buf->next=new;
            tail     =new;
            POS.MAXY++;
         }
         else
         {
            break;
         }
      }
      mark_head=mark_head->next;
      buf=buf->next;
   }

   NowdataToText(now);
   CompareRedraw(POS.SCRY,(LINE.SCRY1-LINE.SCRY+1));

   if(CTRL.MODIFY==OFF)                         // P_ɮ׬O_Qק
   {
      CTRL.MODIFY=ON;
      DisplayFname(FNAME);
   }
   return(0);
}

int MarkWord()
{
   int MARK =OFF;
   int SPACE= -1;
   int markx;
   int marky;

   if(CTRL.MARK && CTRL.MARKFILE!=ACTIVE)
   {
      DisplayMessage("~ : MwsаO۽Ĭ ",ON);
      return(0);
   }
   //if(CTRL.COMMAND) return(0);

   while(1)
   {
      if(POS.NOWX>strlen(text) || POS.NOWX==255)
      {
         if(MARK || POS.NOWY==POS.MAXY)  { MarkBlock(); return(1); }
         Down();
         Home();
         SPACE=ON;                              // Home() TwbU@r
         MARK =ON;
         MarkBlock();
      }
      else
      {
         if(text[POS.NOWX-1]==' ' && SPACE==-1) SPACE=0;
         if(text[POS.NOWX-1]!=' ' && SPACE== 0) { SPACE=1; MARK=ON;  MarkBlock(); }
         if(text[POS.NOWX-1]==' ' && SPACE== 1) { MarkBlock(); return(1); }
         Right();
      }
   }
}

int MarkBlock()
{
   int j,len,scr,cnt,CHINESE;

   if(CTRL.MARK && CTRL.MARKFILE!=ACTIVE)
   {
      DisplayMessage("~ : MwsаO۽Ĭ ",ON);
      return(0);
   }
   //if(CTRL.COMMAND) return(0);

   if(!CTRL.MARK)
   {
      CTRL.MARK=ON;
      CTRL.MARKFILE=ACTIVE;
      POS.MARKY=POS.MARKY1=POS.NOWY;
      POS.MARKX=POS.MARKX1=POS.NOWX;
      CompareRedraw(POS.SCRY,1);
      ChangeMessage();
   }
   else
   {
      if(POS.MARKX==0)                          // w LINE MARK
      {
         POS.MARKY=POS.MARKY1=POS.NOWY;
         POS.MARKX=POS.MARKX1=POS.NOWX;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
      else
      {
         if(POS.NOWY<POS.MARKY)  POS.MARKY=POS.NOWY; else POS.MARKY1=POS.NOWY;
         if(POS.NOWX<POS.MARKX)  POS.MARKX=POS.NOWX; else POS.MARKX1=POS.NOWX;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
   }

   // ------- Mark ̫r, eb, h Mark Ӥr  ----------
   if(CTRL.CHINESE && (len=strlen(text))>POS.MARKX1)
   {
      for(j=0,CHINESE=OFF;j<POS.MARKX1 && j<len;j++)
      {
         if(!CHINESE && (unsigned char)text[j]>0x80) CHINESE=ON; else CHINESE=OFF;
      }
      if(CHINESE && POS.MARKX1!=255) { POS.MARKX1++; Right(); }
   }

   return(1);
}

int MarkLine()
{
   int scr,cnt;

   if(CTRL.MARK && CTRL.MARKFILE!=ACTIVE)
   {
      DisplayMessage("~ : MwsаO۽Ĭ ",ON);
      return(0);
   }
   //if(CTRL.COMMAND) return(0);

   if(!CTRL.MARK)
   {
      CTRL.MARK=ON;
      CTRL.MARKFILE=ACTIVE;
      POS.MARKY=POS.MARKY1=POS.NOWY;
      //if((CTRL.MACRO && MACRO.debug==OFF) || CTRL.PROKEY)
         CompareRedraw(POS.SCRY,1);
      //else
      //   DisplayMark(POS.SCRY,1);
      ChangeMessage();
   }
   else
   {
      if(POS.MARKX!=0)                          // w BLOCK MARK
      {
         POS.MARKY=POS.MARKY1=POS.NOWY;
         POS.MARKX=POS.MARKX1=0;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
      else
      {
         if(POS.NOWY<POS.MARKY)  POS.MARKY=POS.NOWY; else POS.MARKY1=POS.NOWY;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
   }
   return(1);
}

float MarkSum()
{
   struct LINK   *tmp;
   struct BACKUP *BAKtmp=NULL;
   int           i,j;
   int           scrx,scrx1;
   char          str[256],*ts;
   double        result=0;

   if(!CTRL.MARK)  return(0);

   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   MallocData(now,text);
   now=NEW;
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;      // V POS.MARKY 檺

   if(POS.MARKX ==0) scrx =1;   else  scrx =POS.MARKX;
   if(POS.MARKX1==0) scrx1=255; else  scrx1=POS.MARKX1;

   for(i=POS.MARKY;i<=POS.MARKY1;i++)           // MARK ϰJr
   {
      // -------------------- Make Ϫťեh ---------------------
      PointerData(tmp);
      MidStr(str,U_STR,scrx,(scrx1-scrx+1));
      if(!EraseSpace(str)) { tmp=tmp->next; continue; }
      result +=Calc(str);
      tmp=tmp->next;
   }
   NowdataToText(now);
   if(BAKtmp!=NULL) ChangeEditStatus(BAKtmp);   // MARK ɤu@
   sprintf(RESULT,"%.2f",result);
   return(result);
}

int MarkSort(int mode)
{
   struct BACKUP *BAKtmp=NULL;
   struct LINK   *max;
   struct LINK   *buf;
   struct LINK   *new;
   struct LINK   *AP;
   struct LINK   *AN;
   struct LINK   *BP;
   struct LINK   *BN;
   int           i,j;
   int           scr,cnt;
   int           MODIFY=OFF;
   char          *newp,*maxp;
   char          news[256],maxs[256];

   if(!CTRL.MARK)
   {
      DisplayMessage("~ : ݥаOƧǪd ",ON);
      return(0);
   }

   BAKtmp=ACTIVE;
   if(CTRL.MARKFILE!=ACTIVE)
   {
      ChangeEditStatus(CTRL.MARKFILE);
   }
   else
   {
      MallocData(now,text);
      now=NEW;
   }

   buf =head;
   for(i=1;i<POS.MARKY;i++) buf=buf->next;      // V POS.MARKY  

   cnt=(POS.MARKY1-POS.MARKY);
   for(i=0;i<cnt;i++)
   {
      new=buf;
      max=buf;
      maxp=DATAPointerData(max);   strcpy(maxs,maxp);   maxp=maxs;

      for(j=(i+1);j<=cnt;j++)
      {
         new=new->next;

         if(POS.MARKX)                  // BLOCK MARK, HаOϷȧ@Ƨ
         {
            maxp =DATAPointerData(max);
            U_LEN=UnCompressSpace(maxs,maxp);
            if(U_LEN<POS.MARKX) maxp=NULL; else { maxp=maxs+(POS.MARKX-1); }

            newp =DATAPointerData(new);
            U_LEN=UnCompressSpace(news,newp);
            if(U_LEN<POS.MARKX) newp=NULL; else { newp=news+(POS.MARKX-1); }
         }
         else
         {
            newp=DATAPointerData(new);
         }

         switch(mode)
         {
            case 1 : // W, jpg@
                     if(strcmp(newp,maxp) <0)
                     {
                        max=new;
                        if(POS.MARKX==0) strcpy(maxs,newp);
                     }
                     break;
            case 2 : // , jpg@
                     if(strcmp(newp,maxp) >0)
                     {
                        max=new;
                        if(POS.MARKX==0) strcpy(maxs,newp);
                     }
                     break;
            case 3 : // W, jpg@
                     if(stricmp(newp,maxp)<0)
                     {
                        max=new;
                        if(POS.MARKX==0) strcpy(maxs,newp);
                     }
                     break;
            case 4 : // , jpg@
                     if(stricmp(newp,maxp)>0)
                     {
                        max=new;
                        if(POS.MARKX==0) strcpy(maxs,newp);
                     }
                     break;
         }
      }
      if(max!=buf) MODIFY=ON;                        // Qh

      if(buf!=max)
      {
         if(buf->next!=max)
         {
            AP=buf->prev;
            AN=buf->next;
            BP=max->prev;
            BN=max->next;
            if(AP!=NULL) AP->next=max; else head=max;
            if(AN!=NULL) AN->prev=max; else tail=max;
            if(BP!=NULL) BP->next=buf; else head=buf;
            if(BN!=NULL) BN->prev=buf; else tail=buf;
            buf->prev=BP;
            buf->next=BN;
            max->prev=AP;
            max->next=AN;
         }
         else
         {
            AP=buf->prev;
            AN=buf->next;
            BP=max->prev;
            BN=max->next;
            if(AP!=NULL) AP->next=max; else head=max;
            if(BN!=NULL) BN->prev=buf; else tail=buf;
            buf->prev=max;
            buf->next=BN;
            max->prev=AP;
            max->next=buf;
         }
      }
      buf=max;
      buf=buf->next;
   }

   now=head;
   for(i=1;i<POS.NOWY;i++) now=now->next;
   NowdataToText(now);

   // ----- MARK ɬO_u@ , ݤݭs ------
   if(BAKtmp!=CTRL.MARKFILE)
   {
      if(MODIFY) CTRL.MODIFY=ON;
      ChangeEditStatus(BAKtmp);
      DISPLAY.REDISPLAY=OFF;
      DISPLAY.SCRY     =1;
      DISPLAY.CNT      =0;
   }
   else
   {
      if(CTRL.MODIFY==OFF && MODIFY)            // P_ɮ׬O_Qק
      {
         CTRL.MODIFY=ON;
         DisplayFname(FNAME);
      }
      if(MODIFY)
      {
         CompareRedrawArea(POS.MARKY, POS.MARKY1, &scr ,&cnt);;
         CompareRedraw(scr,cnt);
      }
   }
   return(1);
}

void MarkReverse()
{
   struct LINK   *tmp;
   int           i,j,sw,ch,len;
   int           scrx, scrx1;
   int           scrx2,scrx3;
   char          str[512];
   char          str1[256];
   int           CHINESE;
   unsigned char *ts;
   struct BACKUP *BAKtmp=NULL;

   if(!CTRL.MARK)  return;
   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   MallocData(now,text);                        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;      // V POS.MARKY 檺

   if(POS.MARKX ==0) scrx =1;   else  scrx =POS.MARKX;
   if(POS.MARKX1==0) scrx1=255; else  scrx1=POS.MARKX1;

   for(i=POS.MARKY;i<=POS.MARKY1;i++)           // MARK ϰJr
   {
      PointerData(tmp);
      strcpy(str,U_STR);
      len=U_LEN;

      // ----------------- Mark Ĥ@Ӧr, b -----------------
      for(j=0,CHINESE=OFF;j<(scrx-1) && j<strlen(str);j++)
      {
         if(!CHINESE && (unsigned char)str[j]>0x80) CHINESE=ON; else CHINESE=OFF;
      }
      if(CHINESE) scrx2=scrx+1; else scrx2=scrx;

      // ----------------- Mark ̫@r, eb -----------------
      for(j=0,CHINESE=OFF;j<scrx1 && j<strlen(str);j++)
      {
         if(!CHINESE && (unsigned char)str[j]>0x80) CHINESE=ON; else CHINESE=OFF;
      }
      if(CHINESE) scrx3=scrx1-1; else scrx3=scrx1;

      if(scrx2>len)    continue;                // rp MARKX
      if(scrx3<=scrx2) continue;                // MARK ϤӤp

      MidStr(str1,str,scrx2,(scrx3-scrx2+1));
      ts=str1;
      while(*ts!='\0')
      {
         if((unsigned char)(*ts)>0x80)          // rϬ
         {
            ch     =*ts;
            *ts    =*(ts+1);
            *(ts+1)=ch;
            ts++;
         }
         ts++;
      }
      strrev(str1);
      MidReplace(str,str1,scrx2);

      //------  now=tmp , now ]QV NEW ------
      if(tmp==now) { sw=MallocData(tmp,str); now=NEW; } else sw=MallocData(tmp,str);
      if(!sw) break; else { tmp=NEW; tmp=tmp->next; }
   }
   NowdataToText(now);

   // ----- MARK ɬO_u@ , ݤݭs ------
   MarkRedisplay(BAKtmp,1);
}

// ----- MARK ɬO_u@ , ݤݭs ------
// ---- 1 : u MARK ϰ,  0 : ϰ ----
void MarkRedisplay(struct BACKUP *BAKtmp,int mode)
{
   int scr,cnt;

   if(BAKtmp!=NULL)                     // MARK ɤu@ , ݭs
   {
      CTRL.MODIFY=ON;
      ChangeEditStatus(BAKtmp);
      DISPLAY.REDISPLAY=OFF;
      DISPLAY.SCRY     =1;
      DISPLAY.CNT      =0;
   }
   else
   {
      // ------------ P_ɮ׬O_Qק -------------
      if(CTRL.MODIFY==OFF)
      {
         CTRL.MODIFY=ON;
         DisplayFname(FNAME);
      }

      // ---- P_ MARK ϰO_bثeܪϰ ---
      if(mode)
      {
         CompareRedrawArea(POS.MARKY, POS.MARKY1, &scr, &cnt);
         CompareRedraw(scr,cnt);
      }
      else
      {
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
   }
}

int MarkInput(int code)
{
   int           i, ch;
   int           return_code;
   unsigned      al,ah;
   char          str[256],message[80];
   int           scr,  cnt;
   int           scrx, scrx1;
   int           scrx2,scrx3;
   int           SW,EXIT=OFF;

   if(!CTRL.MARK)  return(0);
   if(CTRL.MARKFILE!=ACTIVE) { ChangeEditStatus(CTRL.MARKFILE); }

   if(MONITOR==COLOR) MARKCOLOR=0x60;
   MallocData(now,text);                        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   if(POS.MARKX ==0) scrx =1;   else  scrx =POS.MARKX;
   if(POS.MARKX1==0) scrx1=255; else  scrx1=POS.MARKX1;

   // --------- ШSbثeаO (hваOϭ) -----------
   if(!((POS.NOWY>=POS.MARKY && POS.NOWY<=POS.MARKY1) &&
       (POS.NOWX>=scrx      && POS.NOWX<=scrx1      )) )
   {
      MarkBegin();
      Column(POS.MARKX);
      NowdataToText(now);
   }
   CompareRedrawArea(POS.MARKY, POS.MARKY1, &scr ,&cnt);
   CompareRedraw(scr,cnt);
   Redraw(DISPLAY.SCRY,DISPLAY.CNT);
   LightLine();
   StatusXY();

   // ---------------------------------------------------------------
   strcpy(message,"wubаOϿJ   <ESC>Ѱ  Shift[F7 F8k]  Ctrl[TabŸ][A]");
   DisplayMessageNoBeep(message);

   while(!EXIT)
   {
      if((ch=GetKey())==-1)     continue;               // O_Q
      return_code=0;
      al=((unsigned)ch & 0x00FF);
      ah=((unsigned)ch>>8);
      if(!al)                                           // \QUF
      {
         switch(KEY_STATUS)
         {
             case 0x00 :
                  switch(ah)
                  {
                      case 0x52 : // INS
                           InsertToggle();
                           break;
                      case 0x48 : // UP
                           if(POS.NOWY!=POS.MARKY)  Up();     else { if(code) return_code=1; }
                           break;
                      case 0x50 : // DOWN
                           if(POS.NOWY!=POS.MARKY1) Down();   else { if(code) return_code=2; }
                           break;
                      case 0x4b : // LEFT
                           if(POS.NOWX!=scrx)       Left();   else { if(code) return_code=3; }
                           break;
                      case 0x4d : // RIGHT
                           if(POS.NOWX!=scrx1)      Right();  else { if(code) return_code=4; }
                           break;
                      case 0x47 : // Home
                           Column(scrx);
                           break;
                      case 0x4f : // End
                           Column(scrx1);
                           break;
                      case 0x49 : // PageUp
                           if((POS.NOWY-(LINE.SCRY1-LINE.SCRY+1))>=POS.MARKY)  Pgup(); else { while(POS.NOWY!=POS.MARKY)  Up();   }
                           break;
                      case 0x51 : // PageDown
                           if((POS.NOWY+(LINE.SCRY1-LINE.SCRY+1))<=POS.MARKY1) Pgdn(); else { while(POS.NOWY!=POS.MARKY1) Down(); }
                           break;
                      case 0x53 : // Del
                           if(strlen(text)>scrx1) MidInsert(text," ",scrx1+1);
                           DeleteChar();
                           break;
                  }
                  break;
             case 0x01 :  // RShift
             case 0x02 :  // LShift
             case 0x03 :  // RShift + LShift
                  switch(ah)
                  {
                      case 0x5a : // Shift-f7
                           ShiftLeft(1);
                           break;
                      case 0x5b : // Shift-f8
                           ShiftRight(1);
                           break;
                  }
                  break;
             case 0x04 : // Ctrl+ <...>
                   if(ah==0x94) { Symbol(); DisplayMessageNoBeep(message); }
                   if(ah==0x01)
                   {
                      if(LAST.keystatus==0x04 && LAST.code==1) MarkAlign(0); else MarkAlign(1);
                   }
                   break;
             case 0x08 : // Alt + Ÿ
                  AltSymbol(ch);
                  break;
         }
      }
      else
      {
         switch(KEY_STATUS)
         {
             case 0x01 :  // RShift
             case 0x02 :  // LShift
             case 0x03 :  // RShift + LShift
                  SW=ON;
                  switch(al)
                  {
                     case 0x37 : KeyNormal(tbl[7][0] ); KeyNormal(tbl[7][1] ); break;    // z Shift + '7'
                     case 0x38 : KeyNormal(tbl[8][0] ); KeyNormal(tbl[8][1] ); break;    // s Shift + '8'
                     case 0x39 : KeyNormal(tbl[9][0] ); KeyNormal(tbl[9][1] ); break;    // { Shift + '9'
                     case 0x34 : KeyNormal(tbl[4][0] ); KeyNormal(tbl[4][1] ); break;    // u Shift + '4'
                     case 0x35 : KeyNormal(tbl[5][0] ); KeyNormal(tbl[5][1] ); break;    // q Shift + '5'
                     case 0x36 : KeyNormal(tbl[6][0] ); KeyNormal(tbl[6][1] ); break;    // t Shift + '6'
                     case 0x31 : KeyNormal(tbl[1][0] ); KeyNormal(tbl[1][1] ); break;    // | Shift + '1'
                     case 0x32 : KeyNormal(tbl[2][0] ); KeyNormal(tbl[2][1] ); break;    // r Shift + '2'
                     case 0x33 : KeyNormal(tbl[3][0] ); KeyNormal(tbl[3][1] ); break;    // } Shift + '3'
                     case 0x30 : KeyNormal(tbl[0][0] ); KeyNormal(tbl[0][1] ); break;    // w Shift + 'ins'
                     case 0x2e : KeyNormal(tbl[10][0]); KeyNormal(tbl[10][1]); break;    // x Shift + 'del'
                     default   : SW=OFF; break;
                  }
                  if(SW) break;
             case 0x00 :  // qqU
                  switch(al)
                  {
                      case 0x0d : // ENTER
                           if(POS.NOWY!=POS.MARKY1) Down();
                           break;
                      case 0x09 : // TAB
                           if(POS.NOWX+(TAB_SPACE-((POS.NOWX-1)%TAB_SPACE))<=POS.MARKX1) Tab();
                           break;
                      case 0x08 : // BACKSPACE
                           if(POS.NOWX!=scrx) Left();
                           if(scrx1!=255)     MidInsert(text," ",scrx1+1);
                           DeleteChar();
                           break;
                      case 0x1b : // ESC
                           EXIT=ON;
                           break;
                      default   : // NORMAL LETTER
                           MidStr(str,text,scrx1+1,255);
                           KeyNormal(al);
                           text[scrx1]='\0';
                           strcat(text,str);
                           break;
                  }
                  break;
         }
      }
      if(POS.NOWX>scrx1)
      {
         if(POS.NOWY<POS.MARKY1) { Down(); Column(scrx); } else Column(scrx1);
      }
      if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
      LightLine();
      StatusXY();

      if(LAST.keystatus==0x08 && KEY_STATUS!=0x08) { DisplayMessageNoBeep(message); }
      // ------ OW, ΥHP_O_s Alt-L, Alt-B -----
      LAST.keystatus=KEY_STATUS;
      LAST.code     =ch;
      if(return_code!=0) return(return_code);
   }
   DisplayMessage(" ",OFF);
   if(MONITOR==COLOR) MARKCOLOR=0x40;
   CompareRedrawArea(POS.MARKY,POS.MARKY1,&scr,&cnt);
   CompareRedraw(scr,cnt);
   if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
   return(0);
}

void MarkExchange(int key_status, int code)
{
   struct XY { int x,y; } pos[4];
   struct LINK   *tmp1;
   struct LINK   *tmp2;
   int           ERROR=OFF, EXIT=OFF, CHINESE=OFF;
   int           mark=0;
   int           i, ch;
   unsigned      al,ah;
   int           scr,cnt;
   int           len1,len2;
   char          message[80];
   char          str1[256] ,str2[256];
   char          text1[512],text2[512];

   if(CTRL.COMMAND) CommandToggle(); else { MallocData(now,text); now=NEW; }

   pos[0].x=POS.NOWX;
   pos[0].y=POS.NOWY;

   // ----------------------------------------------------
   if(MONITOR==COLOR) MARKCOLOR=0x30;
   MarkPush();
   MarkBlock();
   CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   Redraw(DISPLAY.SCRY,DISPLAY.CNT);
   LightLine();
   StatusXY();

   strcpy(message,"аOϤ]w, ~]w <ӷаO, ĤGm>,  <ESC> Ѱ");
   if(code==0x2e00) { MidInsert(message," <Alt-C> ",19); }
   DisplayMessageNoBeep(message);
   while(!EXIT)
   {
      if((ch=GetKey())==-1)     continue;               // O_Q
      al=((unsigned)ch & 0x00FF);
      ah=((unsigned)ch>>8);

      if(ERROR) { DisplayMessageNoBeep(message); ERROR=OFF; }

      if(key_status==KEY_STATUS && ch==code)
      {
         switch(mark)
         {
            case 0 :   // ӷаO, ĤGӦm
                 mark++;
                 MarkBlock();
                 StatusXY();
                 pos[1].y=POS.NOWY;
                 pos[1].x=POS.NOWX;
                 if(pos[1].y<pos[0].y) { i=pos[1].y; pos[1].y=pos[0].y; pos[0].y=i; }
                 if(pos[1].x<pos[0].x) { i=pos[1].x; pos[1].x=pos[0].x; pos[0].x=i; }
                 strcpy(message,"аOϤ]w, ~]w <تаO, Ĥ@m>,  <ESC> Ѱ");
                 if(code==0x2e00) { MidInsert(message," <Alt-C> ",19); }
                 DisplayMessageNoBeep(message);
                 //CompareRedrawArea(pos[0].y, pos[1].y, &scr,&cnt);
                 //DisplayMark(scr,cnt);
                 if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
                 break;
            case 1 :   // تаO, Ĥ@Ӧm
                 pos[2].y=POS.NOWY;
                 pos[2].x=POS.NOWX;
                 // ------------ P_аOϬO_| -----------
                 if((pos[2].y>=pos[0].y && pos[2].y<=pos[1].y) &&
                    (pos[2].x>=pos[0].x && pos[2].x<=pos[1].x))
                 {
                    DisplayMessage("تаO, ӷаO ۽Ĭ !!",ON); ERROR=ON; break;
                 }
                 mark++;
                 strcpy(message,"аOϤ]w, ~]w <تаO, ĤGm>,  <ESC> Ѱ");
                 if(code==0x2e00) { MidInsert(message," <Alt-C> ",19); }
                 DisplayMessageNoBeep(message);
                 ColorBgAttrib(POS.SCRX, POS.SCRY," ", MARKCOLOR);
                 break;
            case 2 :   // تаO, ĤGӦm
                 // --- Mark ̫r, eb, h Mark Ӥr  ---
                 for(i=0,CHINESE=OFF;i<POS.NOWX && i<strlen(text);i++)
                 {
                    if(!CHINESE && (unsigned char)text[i]>0x80) CHINESE=ON; else CHINESE=OFF;
                 }
                 if(CHINESE) Right();
                 StatusXY();

                 pos[3].y=POS.NOWY;
                 pos[3].x=POS.NOWX;
                 if(pos[3].y<pos[2].y) { i=pos[3].y; pos[3].y=pos[2].y; pos[2].y=i; }
                 if(pos[3].x<pos[2].x) { i=pos[3].x; pos[3].x=pos[2].x; pos[2].x=i; }

                 // ------------ P_аOϬO_| -----------
                 if((pos[3].y-pos[2].y)!=(pos[1].y-pos[0].y))
                 {
                    DisplayMessage("ӷ,ت аOϰ, аOۦP!!",ON); ERROR=ON; break;
                 }
                 if((pos[2].y>=pos[0].y && pos[2].y<=pos[1].y) &&
                    (pos[2].x>=pos[0].x && pos[2].x<=pos[1].x))
                 {
                    DisplayMessage("تаO, ӷаO ۽Ĭ !!",ON); ERROR=ON; break;
                 }
                 if((pos[2].y>=pos[0].y && pos[2].y<=pos[0].y) ||
                    (pos[3].y>=pos[0].y && pos[3].y<=pos[0].y))
                 {
                    if((pos[2].x>=pos[0].x && pos[2].x<=pos[0].x) ||
                       (pos[3].x>=pos[0].x && pos[3].x<=pos[0].x))
                    {
                       DisplayMessage("تаO, ӷаO ۽Ĭ !!",ON); ERROR=ON; break;
                    }
                 }

                 POS.MARKX =pos[2].x;
                 POS.MARKX1=pos[3].x;
                 POS.MARKY =pos[2].y;
                 POS.MARKY1=pos[3].y;
                 CompareRedrawArea(pos[2].y, pos[3].y, &scr,&cnt);
                 //Redraw(scr,cnt);
                 MARK_EXCHANGE=ON;
                 DisplayMark(scr,cnt);
                 MARK_EXCHANGE=OFF;

                 // ---------------- T{ ----------------
                 DisplayMessageNoBeep("T :  <Esc>    <䥦> T{");
                 LocateXY(40,LINE.MESSAGE);
                 str1[0]=(char)Getch();
                 str1[1]='\0';
                 DisplayMessage(" ",OFF);
                 if(str1[0]==0x1b) { EXIT=ON;  break; }

                 // -------------- аOϤ ----------------
                 for(i=1, tmp1=head; i<pos[0].y; i++) tmp1=tmp1->next;
                 for(i=1, tmp2=head; i<pos[2].y; i++) tmp2=tmp2->next;

                 for(i=0; i<=(pos[1].y-pos[0].y); i++)
                 {
                    if(tmp1!=tmp2)
                    {
                       PointerData(tmp1);  strcpy(text1,U_STR);
                       PointerData(tmp2);  MidStr1(str1,U_STR,pos[2].x,(pos[3].x-pos[2].x+1));
                       MidDelete(text1,pos[0].x,(pos[1].x-pos[0].x+1));
                       MidInsert(text1,str1,pos[0].x);

                       PointerData(tmp1);  MidStr1(str1,U_STR,pos[0].x,(pos[1].x-pos[0].x+1));
                       PointerData(tmp2);  strcpy(text2,U_STR);
                       MidDelete(text2,pos[2].x,(pos[3].x-pos[2].x+1));
                       MidInsert(text2,str1,pos[2].x);

                       text1[255]='\0';
                       text2[255]='\0';
                       MallocData(tmp1,text1); if(now==tmp1) { now=NEW; }  tmp1=NEW;
                       MallocData(tmp2,text2); if(now==tmp2) { now=NEW; }  tmp2=NEW;
                    }
                    else
                    {
                       PointerData(tmp1);  strcpy(text1  ,U_STR);
                       MidStr1(str1,U_STR,pos[0].x,(pos[1].x-pos[0].x+1));
                       MidStr1(str2,U_STR,pos[2].x,(pos[3].x-pos[2].x+1));

                       len1=strlen(str1);
                       len2=strlen(str2);
                       MidInsert(text1,str2,pos[0].x);
                       MidInsert(text1,str1,pos[2].x+len2);

                       MidDelete(text1,pos[2].x+len1+len2,len2);
                       MidDelete(text1,pos[0].x+len2, len1);

                       text1[255]='\0';
                       MallocData(tmp1,text1); if(now==tmp1) { now=NEW; }
                       tmp1=tmp2=NEW;
                    }
                    tmp1=tmp1->next;
                    tmp2=tmp2->next;
                 }
                 if(CTRL.MODIFY==OFF) { CTRL.MODIFY=ON; DisplayFname(FNAME); }
                 EXIT=ON;
                 break;
         }
         continue;
      }

      if(!al)                                           // \QUF
      {
         if(KEY_STATUS==0x00) ProfileKey(ON, KEY_STATUS, ah);   // 
      }
      else
      {
         if(KEY_STATUS==0x00 && al==0x09) ProfileKey(OFF,0,al); // Tab 
         if(al==0x1b) EXIT=ON;
      }
      if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
      LightLine();
      StatusXY();
   }
   if(MONITOR==COLOR) MARKCOLOR=0x40;
   NowdataToText(now);
   DisplayMessage(" ",OFF);
   UnMark();
   MarkPop();
   CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   Redraw(DISPLAY.SCRY,DISPLAY.CNT);
}
