#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <malloc.h>
#include <io.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include "we.h"
#include "tools.h"

#define ON      1
#define OFF     0

extern struct LINE_STRUCT    LINE;
extern int                   KEY_STATUS;
extern char                  STR[513];
extern char                  BOXSTR[1024];
extern char                  M2D[80];

void  DisplayMessage(char *str, int mode);
int   MacroStr(char *str);

struct MENU_STRUCT
{
   int  x;
   char first_char;
   char menuitem[13];
   int  item_cnt;
   char item[20][30];
   char macro[20][60];
   char mess[20][80];
};

int                menu_cnt;
struct MENU_STRUCT *menu;

void HSelectMainDisplay(struct MENU_STRUCT *menu,            int color1);
void VSelectMainDisplay(struct MENU_STRUCT *menu,int now_sel,int color1);
void HSelectMainMenu(int x,int y,struct MENU_STRUCT *menu,int *old_sel,int *new_sel,             int color1,int color2);
void VSelectMainMenu(int x,int y,char cmd[][30]          ,int *old_sel,int *new_sel,int hnow_sel,int color1,int color2);

int  MenuSelect(int *HSEL, int *VSEL);

void HSelectMainDisplay(struct MENU_STRUCT *menu,int color1)
{
   int i,len;

   //---------------------  ----------------------
   ClrScr(1,1,80,1 ,B_LIGHTGRAY);
   for(i=0,len=1;i<menu_cnt;i++)
   {
      ColorPuts1(len,1,menu[i].menuitem,color1);
      ColorPutsAttrib(len+1,1," ",F_WHITE|B_LIGHTGRAY);
      len +=(strlen(menu[i].menuitem)+1);
   }
}

void HSelectMainMenu(int x,int y,struct MENU_STRUCT *menu,int *old_sel,int *new_sel,int color1,int color2)
{
   int i,step;

   Redraw(2,(LINE.SCRY1-LINE.SCRY));
   for(i=0,step=x;i<*old_sel;i++)   step +=strlen(menu[i].menuitem)+1;
   ColorPuts1(step,y,menu[*old_sel].menuitem,color1);
   ColorPutsAttrib(step+1,1," ",F_WHITE|color1);

   *old_sel=*new_sel;

   for(i=0,step=x;i<*old_sel;i++)   step +=strlen(menu[i].menuitem)+1;
   ColorPuts1(step,y,menu[*old_sel].menuitem,color2);
   ColorPutsAttrib(step+1,1," ",F_BLUE|color1);
   //LocateXY(step,y);
}


void VSelectMainDisplay(struct MENU_STRUCT *menu,int now_sel,int color1)
{
   int i;

   //---------------------  ----------------------
   for(i=0;i<menu[now_sel].item_cnt;i++)
   {
      ColorPuts1(menu[now_sel].x,2+i,menu[now_sel].item[i],color1);
   }
}

void VSelectMainMenu(int x,int y,char cmd[][30],int *old_sel,int *new_sel,int hnow_sel,int color1,int color2)
{
   char str[81];

   ColorPuts1(x,y+(*old_sel),cmd[*old_sel],color1);
   *old_sel=*new_sel;
   ColorPuts1(x,y+(*old_sel),cmd[*old_sel],color2);

   sprintf(str,"%-80s",menu[hnow_sel].mess[*old_sel]);
   ColorPuts1(1,25,str,F_CYAN | F_INTENSE |B_BLACK);
   //LocateXY(x,y+(*old_sel));
}


int MenuSelect(int *HSEL, int *VSEL)
{
   int i,len;
   int hnow_sel  ;
   int hnew_sel  ;
   int vnow_sel  ;
   int vnew_sel  ;
   int hcolor1  =B_LIGHTGRAY|F_BLACK;
   int hcolor2  =B_LIGHTGRAY|F_RED;
   int vcolor1  =B_CYAN     |F_WHITE;
   int vcolor2  =B_CYAN     |F_RED;
   union REGS reg1,reg2;

   hnow_sel=*HSEL;
   hnew_sel=*HSEL;
   vnow_sel=*VSEL;
   vnew_sel=*VSEL;

   HSelectMainDisplay(menu,hcolor1);
   HSelectMainMenu(1,1,menu,&hnow_sel,&hnew_sel,hcolor1,hcolor2);

   VSelectMainDisplay(menu,hnow_sel,vcolor1);
   VSelectMainMenu(menu[hnow_sel].x,2,menu[hnow_sel].item,&vnow_sel,&vnew_sel,hnow_sel,vcolor1,vcolor2);


   while(1)
   {
      reg1.h.ah=0;
      int86(0x16,&reg1,&reg2);
      if(reg2.h.al==0)
      {
         switch(reg2.h.ah)
         {
            case 'H': // UP
                      if(vnow_sel==0)
                      {
                         vnew_sel=menu[hnow_sel].item_cnt-1;
                      }
                      else
                      {
                         vnew_sel=vnow_sel-1;
                      }
                      VSelectMainMenu(menu[hnow_sel].x,2,menu[hnow_sel].item,&vnow_sel,&vnew_sel,hnow_sel,vcolor1,vcolor2);
                      break;
            case 'P': // DOWN
                      if(vnow_sel==(menu[hnow_sel].item_cnt-1))
                      {
                         vnew_sel=0;
                      }
                      else
                      {
                         vnew_sel=vnow_sel+1;
                      }
                      VSelectMainMenu(menu[hnow_sel].x,2,menu[hnow_sel].item,&vnow_sel,&vnew_sel,hnow_sel,vcolor1,vcolor2);
                      break;
            case 'K': // LEFT
                      vnow_sel=0;
                      vnew_sel=0;
                      if(hnow_sel==0)
                      {
                         hnew_sel=(menu_cnt-1);
                      }
                      else
                      {
                         hnew_sel=hnow_sel-1;
                      }
                      HSelectMainMenu(1,1,menu,&hnow_sel,&hnew_sel,hcolor1,hcolor2);
                      VSelectMainDisplay(menu,hnow_sel,vcolor1);
                      VSelectMainMenu(menu[hnow_sel].x,2,menu[hnow_sel].item,&vnow_sel,&vnew_sel,hnow_sel,vcolor1,vcolor2);
                      break;
            case 'M': // RIGHT
                      vnow_sel=0;
                      vnew_sel=0;
                      if(hnow_sel==(menu_cnt-1))
                      {
                         hnew_sel=0;
                      }
                      else
                      {
                         hnew_sel=hnow_sel+1;
                      }
                      HSelectMainMenu(1,1,menu,&hnow_sel,&hnew_sel,hcolor1,hcolor2);
                      VSelectMainDisplay(menu,hnow_sel,vcolor1);
                      VSelectMainMenu(menu[hnow_sel].x,2,menu[hnow_sel].item,&vnow_sel,&vnew_sel,hnow_sel,vcolor1,vcolor2);
                      break;
         }
      }
      else
      {
         // -------------------- O_JĤ@Ӧr -------------------
         for(i=0;i<menu_cnt;i++)
         {
            if(toupper(reg2.h.al)==menu[i].first_char)
            {
               if(i==hnow_sel) break;
               vnow_sel=0;
               vnew_sel=0;
               hnew_sel=i;
               HSelectMainMenu(1,1,menu,&hnow_sel,&hnew_sel,hcolor1,hcolor2);
               VSelectMainDisplay(menu,hnow_sel,vcolor1);
               VSelectMainMenu(menu[hnow_sel].x,2,menu[hnow_sel].item,&vnow_sel,&vnew_sel,hnow_sel,vcolor1,vcolor2);
               break;
            }
         }

         switch(reg2.h.al)
         {
            case 13 :
                 *VSEL=vnow_sel;
                 *HSEL=hnow_sel;
                 return(1);
            case 27 :
                 return(-1);
         }
      }
   }
}

void MenuProcess()
{
   unsigned sw;
   unsigned size;
   static   HSEL;
   int      VSEL=0;
   int      wcnt=0;
   int      i,j,len;
   int      fhandle;
   int      item_cnt;
   int      EXIT =OFF;
   int      ERROR=OFF;
   char     *ss,*ts,*ts1;
   char     str[256];

   // ------------------------ ɮŪJ -------------------------
   fhandle=open(M2D,O_RDWR | O_TEXT);
   if(fhandle==-1)
   {
      DisplayMessage("~ : Lk}ҥ\\໲U(EE.M2D)",ON);
      return;
   }

   size=((sizeof(struct MENU_STRUCT)*10)+15)>>4;
   if(allocmem(size,&sw)!=-1)
   {
      DisplayMessage("~ : ǲΰO餣, Lk}ҥ\\",ON);
      return;
   }
   menu    =(struct MENU_STRUCT *)MK_FP(sw,0);
   menu_cnt=-1;
   while(!EXIT)
   {
      // ----------------------- ŪJ@ -----------------------
      ts   =str;
      while(1)
      {
         if(wcnt==0)
         {
            if((wcnt=read(fhandle,STR,512))==0) { EXIT=ON; break; }
            ts1=STR;
         }

         if(*ts1==0x0a || *ts1==0x0d) { wcnt--; ts1++;  break; }
         if(*ts1==0x09) { *ts++=' '; } else { *ts++=*ts1; }
         ts1++;
         wcnt--;
      }
      *ts='\0';

      // ----------------- '#' H ---------------------
      for(i=0;i<strlen(str);i++)  { if(str[i]=='#') { str[i]='\0'; break; } }

      // -------------------- O_D\ --------------------
      if(str[0]!=' ' && str[0]!='\0')
      {
         menu_cnt++;
         if(menu_cnt==10) { EXIT=ON; continue; }
         if(!EraseSpace(str)) continue;
         strncpy(BOXSTR,str,10);
         sprintf(menu[menu_cnt].menuitem," %s ",BOXSTR);
         menu[menu_cnt].first_char=BOXSTR[0];;
         menu[menu_cnt].item_cnt  =0;
         for(i=0;i<20;i++)
         {
            menu[menu_cnt].item[i][0] ='\0';
            menu[menu_cnt].mess[i][0] ='\0';
            menu[menu_cnt].macro[i][0]='\0';
         }
         item_cnt=0;
         continue;
      }

      if(!EraseSpace(str)) continue;
      if(item_cnt==20)     continue;

      // ---------------------- Xت ----------------------
      ss =str;
      ts =BOXSTR;
      while(*ss!='=' && *ss!='\0')  {  *ts++=*ss++;  *ts='\0'; }
      if(*ss=='=') ss++;
      if(!EraseSpace(BOXSTR)) continue; else  BOXSTR[27]='\0';
      sprintf(menu[menu_cnt].item[item_cnt], " %-27s ", BOXSTR);

      // --------------------- Xwq ---------------------
      ts =BOXSTR;
      while(*ss!='=' && *ss!='\0')  {  *ts++=*ss++;  *ts='\0'; }
      if(*ss=='=') ss++;
      if(!EraseSpace(BOXSTR)) continue; else  BOXSTR[59]='\0';

      for(i=0,j=0,ERROR=OFF; i<strlen(BOXSTR); i++)   // P_ '[]' O_
      {
         if(BOXSTR[i]=='[') { j++; if(j>1) { ERROR=ON; break; } }
         if(BOXSTR[i]==']') { j--; if(j<0) { ERROR=ON; break; } }
      }
      if(ERROR) continue;
      strcpy(menu[menu_cnt].macro[item_cnt], BOXSTR);

      // --------------------- XUT ---------------------
      ts =BOXSTR;
      while(*ss!='\0')  {  *ts++=*ss++;  *ts='\0'; }
      if(!EraseSpace(BOXSTR)) BOXSTR[79]='\0';
      strcpy(menu[menu_cnt].mess[item_cnt], BOXSTR);
      menu[menu_cnt].item_cnt=(++item_cnt);
   }
   close(fhandle);

   // ----------------- \ X Щw --------------------
   menu_cnt++;
   for(i=0,len=1;i<menu_cnt;i++)
   {
      if(len>52)  menu[i].x=52;  else menu[i].x=len;
      for(j=0;j<20;j++)
      {
         if(menu[i].item[j][0]=='\0') { menu[i].item_cnt=j; break; }
      }
      len +=strlen(menu[i].menuitem)+1;
   }

   LocateXY(1,1);
   str[0]='\0';
   if(menu_cnt!=0)
   {
      VSEL=0;
      if(HSEL>menu_cnt) HSEL=0;
      if(MenuSelect(&HSEL, &VSEL)!=-1) strcpy(str,menu[HSEL].macro[VSEL]);
   }
   freemem(FP_SEG(menu));

   if(str[0]!='\0') MacroStr(str); else DisplayMessage(" ",OFF);
   CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
}
