
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include "we.h"
#include "allocmem.h"
#include "tools.h"
#include "undo.h"
#include "ems.h"

#define ON            1
#define OFF           0

extern struct UNDO_STRUCT UNDO;
extern struct POS_STRUCT  POS;

struct BACKUP        BAKundo;
extern struct BACKUP *ACTIVE;           // ثeʧ@OӤ (lNULL)
extern struct LINK   *head;
extern struct LINK   *tail;
extern char          FNAME[80];
extern char          *DP;
extern struct BLOCK  *Bhead;
extern struct DATA   *Dhead;

// --------------------------------------------------------------
//  tΪl  .UNDO QUIT 
// --------------------------------------------------------------
void UndoInit()
{
   int         i;
   char        str[256];
   struct LINK *now;

   UNDO.append=OFF;

   for(i=0,str[255]='\0'; i<255; i++) str[i]=' ';
   now=AllocMemString(str);             // now tm 18 para (LINK head + 16 )
   PointerData(now);
   strcpy(DP,"\0");

   now->prev=NULL;
   now->next=NULL;

   // ------ ƥثesɪA ------
   BAKundo.POS.MAXY    =1;
   BAKundo.POS.NOWY    =1;
   BAKundo.POS.NOWX    =1;
   BAKundo.POS.SCRY    =1;
   BAKundo.POS.SCRX    =1;
   BAKundo.POS.MARX    =0;
   BAKundo.POS.OLDY    =1;
   BAKundo.POS.CMD_NOWX=1;
   BAKundo.POS.CMD_SCRX=1;
   BAKundo.POS.CMD_MARX=0;
   BAKundo.POS.CURY    =0;
   BAKundo.POS.CURX    =0;

   BAKundo.CTRL.MODIFY =OFF ;
   BAKundo.CTRL.COMMAND=OFF ;
   BAKundo.CTRL.EXIT   =OFF ;

   strcpy(BAKundo.CMD_TEXT,"\0");
   strcpy(BAKundo.FNAME   ,".UNDO");

   BAKundo.HEAD=now;
   BAKundo.NOW =now;
   BAKundo.TAIL=now;

   UNDO.open       =OFF;
   UNDO.append     =ON;
   UNDO.release    =ON;
   UNDO.memory_full=OFF;
}

// ---------------------------------------------------------------------------
// UndoAppend NbUCaQ, mode=1 ɱj@ UNDO
// 1) FreeMem()
// 2) MallocData()
// 3) Quit() , UNDO.append ]w OFF, HTwƤ|QsW UNDO FILE
// ---------------------------------------------------------------------------
void UndoAppend(char *str, int mode)
{
   #ifndef CSF
      struct DATA *DATAtmp;
      struct LINK *new;
      struct LINK *tmp;
      struct LINK *buf;
      char        *dp;
      char        STR[256];
      static      nowy;
      static      maxy;

      if(mode==0)
      {
         // ---- P椣@@ UNDO, CTRL-BS  nowy |@, ҥH[ maxy @P_ -----
         if(POS.NOWY==nowy && maxy==POS.MAXY) return; else { nowy=POS.NOWY; maxy=POS.MAXY; }

         // --------------------------- ťզ椣 UNDO ----------------------------
         // -------------------------- UNDO file @ UNDO -------------------------
         if(*str==0)                          return;
         if(!UNDO.append || UNDO.memory_full) return;
         if(ACTIVE==&BAKundo)                 return;
      }

      tmp  =BAKundo.TAIL;

      DATAtmp=DATAPointer(tmp);
      if((*DATAtmp).ems_handle!=0x00)
      {
         EMSmapping((*DATAtmp).ems_handle,0,0);
      }
      dp=DATAtmp->data + ((*tmp).data_mark<<4);

      if(StrCmp(str,dp)==0)                return;

      if(UNDO.release && !UNDO.open)
      {
         while(BAKundo.POS.MAXY>100)
         {
            //buf=(BAKundo.HEAD)->next;
            //UndoFreeMem(FP_SEG(BAKundo.HEAD));
            //BAKundo.HEAD=buf;
            //BAKundo.POS.MAXY --;
            buf=(BAKundo.HEAD)->next;
            tmp=buf->next;
            UndoFreeMem(buf);
            (BAKundo.HEAD)->next=tmp;
            tmp->prev           =BAKundo.HEAD;
            BAKundo.POS.MAXY --;
         }
      }

      CompressSpace(STR,str);
      if((new=AllocMemString(STR))==NULL) { UNDO.memory_full=ON; return; }

      DATAtmp=DATAPointer(new);
      if((*DATAtmp).ems_handle!=0x00)
      {
         EMSmapping((*DATAtmp).ems_handle,0,0);
      }
      dp=DATAtmp->data + ((*new).data_mark<<4);
      strcpy(dp,STR);

      tmp         =BAKundo.TAIL;
      new->next   =NULL;
      new->prev   =tmp;
      tmp->next   =new;
      BAKundo.TAIL=new;
      BAKundo.POS.MAXY++;
   #else
      if(str[0]=='\0' || mode) { }
   #endif
}

struct BACKUP *UndoOpen()
{
   #ifndef CSF
      struct   BACKUP *BAKnew;
      struct   BACKUP *BAKtmp;
      int             sw=0;
      char            str[80];

      // ----------------- UNDO file ثes誺ɮ ---------------
      if(ACTIVE==&BAKundo) return(NULL);

      // -------------------- UNDO file wg OPEN -------------------
      if(UNDO.open)
      {
         ChangeEditStatus(ACTIVE);
         ChangeFile(&BAKundo);
         return(NULL);
      }

      // ------------------------------------------------------------
      BAKtmp=ACTIVE->next;
      while(BAKtmp!=NULL)
      {
         if(BAKtmp==ACTIVE) break; else { BAKtmp=BAKtmp->next; sw++; }
      }

      if(sw==MAXOPEN && FREE)
      {
         sprintf(str,"~ : KO̦huPɶ} %d ɮ",MAXOPEN);
         return(NULL);
      }

      // ---------------------- } UNDO file ----------------------
      ChangeEditStatus(ACTIVE);
      UNDO.open   =ON;
      UNDO.append =ON;
      UNDO.release=OFF;
      BAKnew      =&BAKundo;

      BAKtmp      =ACTIVE->next;
      ACTIVE->next=BAKnew;
      BAKtmp->prev=BAKnew;
      BAKnew->prev=ACTIVE;
      BAKnew->next=BAKtmp;

      ChangeFile(BAKnew);
      return(BAKnew);
   #else
      return(NULL);
   #endif

}


// --------------------------------------------------------------------
//   AllocMem() Ѯ, | UndoClose() HMXjO^Ŷ
// --------------------------------------------------------------------
void UndoClose()
{
   struct LINK *buf;
   struct LINK *tmp;

   if(UNDO.open) return;

   tmp=BAKundo.HEAD;
   while(tmp!=NULL)
   {
      buf=tmp->next;
      UndoFreeMem(tmp);
      tmp=buf;
   }
   UndoInit();
}

// --------------------------------------------------------------------
//   tε,  UndoFree(), MҦ memory (EMS)
// --------------------------------------------------------------------
void UndoFree()
{
   struct LINK *buf;
   struct LINK *tmp;

   tmp=BAKundo.HEAD;
   while(tmp!=NULL)
   {
      buf=tmp->next;
      UndoFreeMem(tmp);
      tmp=buf;
   }
}

// --------------------------------------------------------------------
//  P FreeMem() uOA UndoAppend() , HKΦ recursive j
// --------------------------------------------------------------------
void UndoFreeMem(struct LINK *LINKtmp)
{
   struct BLOCK *BLOCKtmp;
   struct BLOCK *BLOCKprev;
   struct BLOCK *BLOCKnext;
   struct DATA  *DATAtmp;
   struct DATA  *DATAprev;
   struct DATA  *DATAnext;
   int          i;

   // ---------------------- BLOCK Ŷ^ ----------------------
   BLOCKtmp=BLOCKPointer(LINKtmp);
   (*BLOCKtmp).useable ++;
   i=(*LINKtmp).block_mark;
   switch(i%8)
   {
      case  0 : (*BLOCKtmp).mark[i/8] &=0x7f; break;
      case  1 : (*BLOCKtmp).mark[i/8] &=0xbf; break;
      case  2 : (*BLOCKtmp).mark[i/8] &=0xdf; break;
      case  3 : (*BLOCKtmp).mark[i/8] &=0xef; break;
      case  4 : (*BLOCKtmp).mark[i/8] &=0xf7; break;
      case  5 : (*BLOCKtmp).mark[i/8] &=0xfb; break;
      case  6 : (*BLOCKtmp).mark[i/8] &=0xfd; break;
      case  7 : (*BLOCKtmp).mark[i/8] &=0xfe; break;
   }

   // ---------------------- DATA  Ŷ^ ----------------------
   DATAtmp=DATAPointer(LINKtmp);
   (*DATAtmp).useable += (*LINKtmp).data_size;
   for(i=(*LINKtmp).data_mark; i<((*LINKtmp).data_mark+(*LINKtmp).data_size); i++)
   {
       switch(i%8)
       {
          case  0 : (*DATAtmp).mark[i/8] &=0x7f; break;
          case  1 : (*DATAtmp).mark[i/8] &=0xbf; break;
          case  2 : (*DATAtmp).mark[i/8] &=0xdf; break;
          case  3 : (*DATAtmp).mark[i/8] &=0xef; break;
          case  4 : (*DATAtmp).mark[i/8] &=0xf7; break;
          case  5 : (*DATAtmp).mark[i/8] &=0xfb; break;
          case  6 : (*DATAtmp).mark[i/8] &=0xfd; break;
          case  7 : (*DATAtmp).mark[i/8] &=0xfe; break;
       }
   }
   LINKtmp=NULL;

   if((*BLOCKtmp).useable==1024)                  //  BLOCK wϥΤF
   {
      if(BLOCKtmp==Bhead) Bhead=BLOCKtmp->next;
      BLOCKprev=BLOCKtmp->prev;
      BLOCKnext=BLOCKtmp->next;
      if(BLOCKprev!=NULL) BLOCKprev->next=BLOCKnext;
      if(BLOCKnext!=NULL) BLOCKnext->prev=BLOCKprev;
      freemem(FP_SEG(BLOCKtmp));
   }

   if((*DATAtmp).useable==1024)                  //  DATA  wϥΤF
   {
      if(DATAtmp==Dhead) Dhead=DATAtmp->next;
      DATAprev=DATAtmp->prev;
      DATAnext=DATAtmp->next;
      if(DATAprev!=NULL) DATAprev->next=DATAnext;
      if(DATAnext!=NULL) DATAnext->prev=DATAprev;
      if(DATAtmp->ems_handle!=0x00)
      {
         EMSfreeblock(DATAtmp->ems_handle);
      }
      else
      {
         freemem(FP_SEG(DATAtmp->data));
      }
      freemem(FP_SEG(DATAtmp));
   }
   UNDO.memory_full=OFF;
}
